#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
using namespace std;

struct point
{
	int x, y;
	point (){}
	point(int x, int y): x(x), y(y) {}
	point(point a, point b)
	{
		x = b.x - a.x;
		y = b.y - a.y;
	}
	int len()
	{
		return x*x + y*y;
	}
};

bool operator < (const point &a, const point &b)
{
	return (a.x < b.x) || (a.x == b.x && a.y < b.y);
}

map<point, int> mp;

vector<pair<point, int> > a;

bool used[22222];
int ans[22222], go[22222];

int cross(point a, point b)
{
	return a.x * b.y - a.y * b.x;
}

void djarvis()
{
	int n = a.size();
	int mni = 0;
	for(int i = 1; i < n; i++)
	{
		if (a[i].first.x < a[mni].first.x || (a[i].first.x == a[mni].first.x && a[i].first.y < a[mni].first.y))
		{
			mni = i;
		}
	}
	while (true) {
		//cout << mni << endl;
		if (used[a[mni].second]) break;
		int v = mni;
		used[a[v].second] = true;
		mni = (v + 1);
		if (mni == n) 
			mni = 0;
		for(int i = 0; i < n; i++)
		{
			if (v == i) continue;
			if (cross(point(a[v].first, a[mni].first), point(a[v].first, a[i].first)) > 0 || (cross(point(a[v].first, a[mni].first), point(a[v].first, a[i].first)) == 0 &&
																							point(a[v].first, a[mni].first).len() < point(a[v].first, a[i].first).len())) {
				mni = i;
			}
		}
		
		if (a[v].first.x != a[mni].first.x || a[v].first.y != a[mni].first.y)
		{
			for(int i = 0; i < n; i++)
			{
				if (i == v || i == mni) 
					continue;
				if (cross(point(a[v].first, a[mni].first), point(a[v].first, a[i].first)) == 0)
				{
					used[a[i].second] = true;
				}
			}
		}
		
	}
}

int main()
{
	int n;
	scanf("%d", &n);
	for(int i = 0; i < n; i++)
	{
		point t;
		scanf("%d%d", &t.x, &t.y);
		if (mp[t] != 0)
		{
			go[i] = mp[t];
		} else {
			a.push_back(make_pair(t, i));
			mp[t] = i + 1;
		}
	}
	int k = 1;
	while (a.size() > 0)
	{

		djarvis();
		int l = 0;
		for(int i = 0; i < a.size(); i++)
		{
			if (used[a[i].second]) {
				ans[a[i].second] = k;
			} else {
				a[l++] = a[i];
			}
		}
		a.resize(l);
		k++;
	}
	for(int i = 0; i < n; i++)
	{
		if (go[i] == 0)
			printf("%d\n", ans[i]);
		else
			printf("%d\n", ans[go[i] - 1]);
	}
	return 0;
}