#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

struct Point
{
	double x, y;
	Point(){}
	Point(double _x, double _y) : x(_x), y(_y) {}
	Point (Point p1, Point p2)
	{
		x = p2.x - p1.x;
		y = p2.y - p1.y;
	}
	double operator % (Point an)
	{
		return x * an.y - y * an.x;
	}
};

const double eps = 1.0e-9;

double answer = 0.0;
Point P;

inline int sgn(double x)
{
	if (abs(x) < eps)
		return 0;
	return (x > eps ? 1 : -1);
}

void go(Point p1, Point p2, Point p3, double cur)
{
	if (cur < eps)
		return;
	Point mid((p2.x + p3.x) / 2.0, (p2.y + p3.y) / 2.0);
	Point vect1(p1, mid);
	Point vect2(p1, P);
	double pr1 = vect1 % vect2;
	Point vect3(p1, Point(0.0, 0.0));
	double pr2 = vect1 % vect3;
	if (sgn(pr1) != sgn(pr2))
		answer += cur; 
	if (sgn(pr1) == 0)
		return;
	//if (abs(pr) < eps)
	//	return;
	
	
	if (pr1 < -eps)
	{
		//answer += cur;
		go(mid, p3, p1, cur / 2.0);
		//go(mid, p1, p3, cur / 2.0);
		
	}
	else
	{
		
		go(mid, p1, p2, cur / 2.0);
		//go(mid, p2, p1, cur / 2.0);
		
	}
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	scanf("%lf%lf", &P.x, &P.y);
	go(Point(10.0, 0.0), Point(0.0, 0.0), Point(10.0, 10.0), 25.0);	
	printf("%.10lf", answer);
}