﻿#include <iostream>
#include <cstdio>
#include <algorithm>
#include <string>

using namespace std;
struct point
{
	int x,y,z;
};
struct pov
{
	int A,B,C,D;
};

point vect(point A, point B)
{
	point x = {(B.x-A.x),(B.y-A.y),(B.z-A.z)};
	return x;
}
pov plosk(point A, point B, point C)
{
	point v1 = vect(A,B),v2 = vect(A,C);
	int a,b,c,d;
	a = (v1.y * v2.z) - (v1.z * v2.y);
	b = (v1.z * v2.x) - (v1.x * v2.z);
	c = (v1.x * v2.y) - (v1.y * v2.x);
	d = -(A.x * a) - (A.y * b) - (A.z * c); 
	pov g = {a,b,c,d};
	return g;
}

double dist(point A, point B, point C , point E)
{
	pov g = plosk(A,B,C);
	double d;
	d = abs(g.A * E.x + g.B * E.y + g.C * E.z + g.D + 0.0) / sqrt(g.A * g.A + g.B * g.B + g.C * g.C + 0.0);
	return d;
}


int main()
{
	freopen("input.txt","r",stdin);
	freopen("output.txt","w",stdout);
	
	point A,B,C,D,F,a,b,c;
	pov g;
	double m;
	cin >> m >> F.z >> D.z;
	cin >> F.x >> F.y;
	cin >> A.x >> A.y; A.z = 0;
	cin >> B.x >> B.y; B.z = 0;
	cin >> C.x >> C.y; C.z = 0;
	cin >> D.x >> D.y;

	double d1,d2,d3,d4,d;

	d1 = dist(A,B,C,F);
	d2 = dist(A,D,B,F);
	d3 = dist(A,D,C,F);
	d4 = dist(D,C,B,F);
	d = min(min(min(d1,d2),d3),d4);
	m = m - F.z - d;
	if(m >= 0) cout << "YES";
	else cout << "NO";
}
