#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

struct pt {
	ld x, y, z;
	pt (ld x = 0, ld y = 0, ld z = 0): x(x), y(y), z(z) {}
};

struct Input {
	pt a[4];
	pt b;
	ld m;
	
	bool read () {
		ld h, H;
		if (!(cin >> m >> h >> H)) {
			return 0;
		}
		cin >> b.x >> b.y;
		b.z = h;
		forn (i, 4) {
			cin >> a[i].x >> a[i].y;
		}
		a[3].z = H;
		return 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	bool res;
	
	void write () {
		puts(res ? "YES" : "NO");
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

struct Solution: Data {
	pt c[3], d;

	ld k1;
	
	ld check3 (ld k2) {
		return sqrtl(sqr(d.x - k1 * c[0].x - k2 * c[1].x) + sqr(d.y - k1 * c[0].y - k2 * c[1].y) + sqr(d.z - k1 * c[0].z - k2 * c[1].z));
	}
	
	ld check2 (ld k1_) {
		k1 = k1_;
		ld l = 0, r = 1 - k1;
		forn (i, 200) {
			ld m1 = (2 * l + r) / 3;
			ld m2 = (2 * r + l) / 3;
			if (check3(m1) < check3(m2)) {
				r = m2;
			} else {
				l = m1;
			}
		}
		return check3((l + r) / 2);
	}
	
	ld check1 () {
		ld l = 0, r = 1;
		forn (i, 200) {
			ld m1 = (2 * l + r) / 3;
			ld m2 = (2 * r + l) / 3;
			if (check2(m1) < check2(m2)) {
				r = m2;
			} else {
				l = m1;
			}
		}
		return check2((l + r) / 2);
	}
	
	void solve () {
		m -= b.z;
		if (m < 0) {
			res = 0;
			return;
		}
		res = 0;
		forn (i, 4) {
			d = b;
			forn (j, 3) {
				c[j] = a[(i + j) % 4];
			}
			forn (j, 2) {
				c[j].x -= c[2].x;
				c[j].y -= c[2].y;
				c[j].z -= c[2].z;
			}
			d.x -= c[2].x;
			d.y -= c[2].y;
			d.z -= c[2].z;
			res |= (check1() < m + 1e-10l);
		}
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("f.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
	sol.read();
	sol.solve();
	sol.write();
#endif
	return 0;
}
