#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <limits.h>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <hash_set>
#include <hash_map>
#include <utility>
#include <stdio.h>
#include <time.h>
#include <memory.h>
#include <string.h>
using namespace std;

#define EPS 1E-7
#define MOD 10007
#define mp make_pair

long long m,h,H;

struct pt{
	long long x,y,z;
	void read(){
		cin>>x>>y>>z;
	}
};

struct plane{
	long long A,B,C,D;
	plane(pt a, pt b, pt c){
		A = (b.y-a.y)*(c.z-a.z)-(b.z-a.z)*(c.y-a.y);
		B = -((b.x-a.x)*(c.z-a.z)-(b.z-a.z)*(c.x-a.x));
		C = (b.x-a.x)*(c.y-a.y)-(b.y-a.y)*(c.x-a.x);
		D = -A*a.x - B*a.y - C*a.z;
	}
};


int main(){
	freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
	cin>>m>>h>>H;
	pt a,b,c,d,e;
	a.read();
	b.read();
	c.read();
	d.read();
	e.read();

	a.z = h;
	m-=h;
	if(m<=0){
		puts("NO");
		return 0;
	}

	plane p1(b,c,d),p2(b,c,e),p3(b,d,e),p4(c,d,e);

	if(m*m*(p1.A*p1.A+p1.B*p1.B+p1.C*p1.C) >= (p1.A*a.x + p1.B*a.y + p1.C*a.z + p1.D)*(p1.A*a.x + p1.B*a.y + p1.C*a.z + p1.D)){
		puts("YES");
		return 0;
	}
	if(m*m*(p2.A*p2.A+p2.B*p2.B+p2.C*p2.C) >= (p2.A*a.x + p2.B*a.y + p2.C*a.z + p2.D)*(p2.A*a.x + p2.B*a.y + p2.C*a.z + p2.D)){
		puts("YES");
		return 0;
	}
	if(m*m*(p3.A*p3.A+p3.B*p3.B+p3.C*p3.C) >= (p3.A*a.x + p3.B*a.y + p3.C*a.z + p3.D)*(p3.A*a.x + p3.B*a.y + p3.C*a.z + p3.D)){
		puts("YES");
		return 0;
	}
	if(m*m*(p4.A*p4.A+p4.B*p4.B+p4.C*p4.C) >= (p4.A*a.x + p4.B*a.y + p4.C*a.z + p4.D)*(p4.A*a.x + p4.B*a.y + p4.C*a.z + p4.D)){
		puts("YES");
		return 0;
	}
	puts("NO");

	return 0;
}
