#include <stdio.h>
#include <math.h>
double m, h, H;
double x[5], y[5];
const double EPS = 1.e-8;

double dist(int i, int j)
{
	double X1 = x[i]-x[j];
	double Y1 = y[i]-y[j];
	double X2 = x[4]-x[j];
	double Y2 = y[4]-y[j];
	double a = Y1*H;
	double b = -H*X1;
	double c = X1*Y2 - Y1*X2;
	double d = a*x[i] + b*y[i];
	return fabs(a*x[0] + b*y[0] + c*h - d) / sqrt(a*a + b*b + c*c);
}

int main()
{
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	scanf("%lf%lf%lf", &m, &h, &H);
	for (int i = 0; i < 5; i++)
		scanf("%lf%lf", &x[i], &y[i]);
	double r = m - h;
	if (r < -EPS)
	{
		printf("NO\n");
		return 0;
	}
	if (dist(1,2) < r+EPS || dist(2,3) < r+EPS || dist(3,1) < r+EPS || h < r+EPS)
		printf("YES\n");
	else	
		printf("NO\n");
	return 0;
}
