#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;
#define fname ""
#define pb push_back
#define y1 y1asd
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
#define sqr(x) (x)*(x)
const int maxn = (int)1e6;
const int inf = (1 << 30) - 1;
const double badP = 12345676543.0;
const double eps = 1e-9;



double m, h, H;
double x[5], y[5], z[5];
double A, B, C, D;


double det(double a, double b, double c, double d) {
	return a * d - b * c;
}
 
void getRes(double x1, double y1, double z1, double x2, double y2, double z2, double x3, double y3, double z3) {
	x2 -= x1, x3 -= x1;
	y2 -= y1, y3 -= y1;
	z2 -= z1, z3 -= z1;
	A = det(y2, z2,
			y3, z3);
	
	B =-det(x2, z2,
			x3, z3);

	C = det(x2, y2,
			x3, y3);
	
	D = - ( x1 * A + y1 * B + z1 * C );
}

int main()
{

	
	cin >> m >> h >> H;
	for (int i = 0; i < 5; i++) {
		scanf("%lf%lf", &x[i], &y[i]);

	}
	z[0] = h;  	
	z[4] = H;
	
	double ans = inf;
	for (int i = 1; i < 5; i++)
		for (int j = i+1; j < 5; j++)
			for (int k = j+1; k < 5; k++) {
				getRes(x[i], y[i], z[i], x[j], y[j], z[j], x[k], y[k], z[k]);
				double dist = fabs(A * x[0] + B * y[0] + C * z[0] + D) / (sqrt(A * A + B * B + C * C));
				ans = min(ans, dist);
			}
	if (ans < m - h) cout << "YES";
	else cout << "NO";
	
	return 0;
}







