#include<iostream>
#include<math.h>
#include<stdio.h>
#include<algorithm>
#include<map>
using namespace std;

int sqr(int n)
{
	return n*n;
}


struct TPoint
{
	int x,y,index;
	void scan() { scanf("%d%d",&x,&y); }
	TPoint(int _x=0,int _y=0,int i=0) {x=_x;y=_y;index=i;}
	int operator* (const TPoint &p) const { return x*p.y-y*p.x; }
	TPoint operator- (const TPoint &p) { return TPoint(x-p.x,y-p.y); }
	void operator-= (const TPoint &p)
	{
		x-=p.x;
		y-=p.y;
	}
	int len() const { return sqr(x)+sqr(y); }
	bool operator< (const TPoint &p) const 
	{
		if(x!=p.x) return (x<p.x);
		return y<p.y;
	}
	void print() { printf("[%d %d | %d]\n",x,y,index); }

};

bool cmp_mul(const TPoint &a,const TPoint &b)
{
	int v = (a*b);
	if(v==0) return a.len()<b.len();
	return (v<0);
}



const int MAX_N = 30000;

int same[MAX_N],convNumber[MAX_N];
TPoint p[MAX_N];
TPoint m[MAX_N];
int N;
map<int,map<int,int>> T;


bool check(TPoint a,TPoint b,TPoint c)
{
	b=b-a;
	c=c-a;
	return (b*c>0); 
}


void convexHULL(int convNum)
{
	int i;
	TPoint p0 = p[0];
	for(i=0;i<N;i++)
		if(p[i]<p0) p0=p[i];
	for(i=0;i<N;i++) p[i]-=p0;
	sort(p,p+N,cmp_mul);
	p[N++]=TPoint();
//	for(i=0;i<N;i++) p[i].print();
//	printf("\n");
	int index = 0;
	m[index++]=p[0];
	if(N>=2) m[index++]=p[1];
	for(i=2;i<N;i++)
	{
		while(index>=2 && check(m[index-2],m[index-1],p[i])) index--;
		m[index++]=p[i];
	}
	for(i=0;i<index;i++) convNumber[m[i].index]=convNum;
	int newN=0;
	for(i=0;i<N;i++)
		if(convNumber[p[i].index]==0) p[newN++]=p[i];
	N = newN;
}


int main()
{
	int i,M=0;
	scanf("%d",&M);

	for(i=0;i<M;i++)
	{
		p[N].scan();
		p[N].index=i+1;
		if(T[p[N].x][p[N].y])
		{
			same[i+1]=T[p[N].x][p[N].y];
		}
		else
		{
			T[p[N].x][p[N].y]=p[N].index;
			N++;
		}
	}
	for(i=1;N;i++)
	{
		convexHULL(i);
	}
	for(i=1;i<=M;i++)
	{
		if(same[i]) convNumber[i]=convNumber[same[i]];
		printf("%d\n",convNumber[i]);
	}
	return 0;
}

