#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <limits.h>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <hash_set>
#include <hash_map>
#include <utility>
#include <stdio.h>
#include <time.h>
#include <memory.h>
#include <string.h>
using namespace std;

#define EPS 1E-7
#define MOD 10007
#define INF 2000000000

#define mp make_pair

struct pt{
	long long x, y;
};

pair<pt,int> Left;

bool cmp(pair<pt,int> a, pair<pt,int> b){
	if((a.first.x-Left.first.x)*(b.first.y-Left.first.y) - (a.first.y-Left.first.y)*(b.first.x-Left.first.x) == 0){
		return (a.first.x-Left.first.x)*(a.first.x-Left.first.x)+(a.first.y-Left.first.y)*(a.first.y-Left.first.y) > 
			(b.first.x-Left.first.x)*(b.first.x-Left.first.x)+(b.first.y-Left.first.y)*(b.first.y-Left.first.y);
	}
	return ((a.first.x-Left.first.x)*(b.first.y-Left.first.y) - (a.first.y-Left.first.y)*(b.first.x-Left.first.x) > 0);
}

int main(){
	freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);

	int N;
	cin>>N;
	vector<pair<pt,int>>vec(N);
	for(int i=0; i<N; ++i){
		cin>>vec[i].first.x >> vec[i].first.y;
		vec[i].second = i;
	}

	vector<int>res(N);
	vector<int>used(N);

	int filled=0;
	int currnum=0;
	int  n = N;
	while(filled < N){
		currnum++;
		if(n<3){
			for(int i=0; i<n; ++i){
				res[vec[i].second]=currnum;
			}
			filled+=n;
			break;
		}
		stack<pair<pt,int>>st;
		int Leftmost = -1;
		for(int i=0; i<n; ++i){
			if(Leftmost==-1 || (vec[i].first.x < vec[Leftmost].first.x)){
				Leftmost = i;
			}
		}
		Left = vec[Leftmost];
		
		vec.erase(vec.begin()+Leftmost);
		n--;
		sort(vec.begin(), vec.end(), cmp);
		st.push(Left);
		st.push(vec[0]);
		pair<pt,int> prev, pprev;
		for(int i=1; i<n; ++i){
			prev = st.top();
			st.pop();
			pprev = st.top();
			st.push(prev);
			while(st.size() > 1 && (prev.first.x-pprev.first.x)*(vec[i].first.y-prev.first.y) - (prev.first.y-pprev.first.y)*(vec[i].first.x-prev.first.x) < 0){
				st.pop();
				if(st.size() == 1){
					break;
				}
				prev=pprev;
				st.pop();
				pprev = st.top();
				st.push(prev);
			}
			st.push(vec[i]);
		}
		while(!st.empty()){
			prev = st.top();
			st.pop();
			used[prev.second]=1;
			res[prev.second]=currnum;
			filled++;
		}
		vec.push_back(Left);
		vector<pair<pt,int>>vec1;
		for(int i=0; i<vec.size(); ++i){
			if(!used[vec[i].second]){
				vec1.push_back(vec[i]);
			}
		}
		vec = vec1;
		n = vec1.size();
	}
		
	for(int i=0; i<res.size(); ++i){
		printf("%d\n", res[i]);
	}


	return 0;
}
