#include <stdio.h>
#include <string.h>
#include <math.h>

#include <iomanip>
#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>

using namespace std;

struct point
{
    long double x, y;
};
struct point3
{
    int x, y, z;
};

int n;
point3 v[105];
int nr[105];
point care[105][11005];

const long double eps = 0.000000001;

long double arie (point a, point b, point c)
{
    long double x;
    x = (a.x * b.y) + (b.x * c.y) + (c.x * a.y) - (a.y * b.x) - (b.y * c.x) - (c.y * a.x);
    return x;
}

point pp;

int cmp2 (point a, point b)
{
    if (fabs (b.x - a.x) <= eps)
        return a.y < b.y;
    return a.x < b.x;
}

int iden (point a, point b)
{
    return fabs (a.x - b.x) <= eps && fabs (a.y - b.y) <= eps;
}

long double baga (point v[], int n)
{
    if (n <= 2)
        return 0.0;

    int i;
    int st[11005] = {0}, viz[11005] = {0};
    int nr = 0;
    sort (v + 1, v + n + 1, cmp2);
    for (i = 1; i < n; i ++)
        if (iden (v[i], v[i + 1]) == 0)
            v[++ nr] = v[i];
    v[++nr] = v[n];
    n = nr;
    st[0] = 0;
    for (i = 1; i <= n; i ++)
    {
        while (st[0] >= 2 && arie (v[st[st[0] - 1]], v[st[st[0]]], v[i]) > -eps)
            st[0] --;
        st[++st[0]] = i;
    }
    for (i = 1; i <= st[0]; i ++)
        viz[st[i]] = 1;
    viz[1] = 0;
    for (i = n - 1; i >= 1; i --)
    {
        if (viz[i])
            continue;
        while (st[0] >= 2 && arie (v[st[st[0] - 1]], v[st[st[0]]], v[i]) > -eps)
            st[0] --;
        st[++st[0]] = i;
    }
    if (st[0] <= 2)
        return 0.0;
    long double sol = 0.0;
    for (i = 1; i < st[0]; i ++)
        sol += -arie (v[0], v[st[i]], v[st[i + 1]]);
    return sol * 0.5;
}

int main ()
{
#ifdef local
    freopen ("a.in", "r", stdin);
    freopen ("a.out", "w", stdout);
#endif

    int i, j, k;
    int zmin, zmax;

    scanf ("%d %d %d", &n, &zmin, &zmax);
    for (i = 1; i <= n; i ++)
    {
        scanf ("%d %d %d", &v[i].x, &v[i].y, &v[i].z);
        if (zmin <= v[i].z && v[i].z <= zmax)
            care[v[i].z][++nr[v[i].z]] = (point){(long double)v[i].x, (long double)v[i].y};
    }
    for (i = zmin; i <= zmax; i ++)
    {
        for (j = 1; j <= n; j ++)
            for (k = 1; k <= n; k ++)
            {
                if (j == k)
                    continue;
                if (v[j].z == v[k].z)
                    continue;
                if (v[j].z == i && v[k].z == i)
                    continue;
                if (!(v[j].z < i && i < v[k].z))
                    continue;
                int z = i;
                int z2 = v[k].z;
                int z1 = v[j].z;
//                long double y = ((long double)z - z2) / (z1 - z2) * v[j].y + ((long double)z1 - z) / (z1 - z2) * v[k].y;
//                long double x = ((long double)z - z2) / (z1 - z2) * v[j].x + ((long double)z1 - z) / (z1 - z2) * v[k].x;
                long double x = v[j].x + ((long double)v[k].x - v[j].x) / ((long double)v[k].z - v[j].z) * (i - v[j].z);
                long double y = v[j].y + ((long double)v[k].y - v[j].y) / ((long double)v[k].z - v[j].z) * (i - v[j].z);
                care[i][++nr[i]] = (point){x, y};
            }
        long double sol = baga (care[i], nr[i]);
//        sol = fabs (sol);
        cout << setprecision(8) << fixed << sol << '\n';
    }
    return 0;
}
