#include<iostream>
#include<cmath>

using namespace std;

typedef struct un_punct {
    int x;
    int y;
    int z;
} pct;

pct p[10];

typedef struct un_plan {
    int a;
    int b;
    int c;
    int d;
}plan;

plan pl[10];

int square(int x) {
    return x * x;
}

double distance(pct p, plan pl) {
    return (double)abs(pl.a * p.x + pl.b * p.y + pl.c * p.z + pl.d)/sqrt(square(pl.a) + square(pl.b) + square(pl.c));
}

void det_plan(pct p1, pct p2, pct p3, plan &p) {
    p.a = (p2.y - p1.y) * (p3.z  - p1.z)- (p2.z - p1.z) * (p3.y - p1.y);
    p.b = (p3.x - p1.x) * (p2.z - p1.z) - (p3.z - p1.z) * (p2.x - p1.x);
    p.c = (p2.x -p1.x) * (p3.y - p1.y) - (p2.y - p1.y) * (p3.x - p1.x);
    p.d = -p1.x * (p2.y - p1.y) * (p3.z  - p1.z) - p1.z * (p2.x  - p1.x) * (p3.y - p1.y) - p1.y * (p3.x - p1.x) * (p2.z - p1.z) +
        p1.z * (p2.y - p1.y) * (p3.x - p1.x) + p1.x * (p2.z - p1.z) *(p3.y - p1.y) + p1.y * (p3.z - p1.z) * (p2.x - p1.x);
}
int main()
{
    int m, h, H;
    double minim=1000000;
    cin >> m >> h >> H;
    for(int i = 0; i < 5; ++i) {
        cin >> p[i].x >> p[i].y;
        p[i].z = 0;
    }
    p[0].z = h;
    p[4].z = H;
    det_plan(p[1], p[2], p[3], pl[0]);
    det_plan(p[1], p[2], p[4], pl[1]);
    det_plan(p[2], p[3], p[4], pl[2]);
    det_plan(p[1], p[3], p[4], pl[3]);

    for(int i = 0; i < 4; ++i) {
        minim = min(minim, distance(p[0], pl[i]));
    }

    if(h + minim <= m)
    cout << "YES";
    else
        cout <<"NO";

}
